from etl import cleaning
import logging
import pandas as pd 
from typing import Optional
from datetime import datetime
from etl.extract import Extract
from utils import Utils
from etl.validation import Validation
import os
from pathlib import Path
from etl.loads import Loads
from settings import load_env_var
from generating_data import Generate_Data
import numpy as np
class Pipeline():
    """
    The code here has been tested and is working correctly bear in mind in case of error it may be from Hopsworks validation
    Line 58-59 can be deleted in case of error 
    version Used is 4
    """
    def __init__(self,logger:logging.log,
                 version:int=None,
                 feature_gp_name:Optional[str]=None,
                 description:Optional[str]=None,
                 project_name:Optional[str]=None
                 ):
        self.log = logger 
        self.feature_gp_name = feature_gp_name
        self.version = version
        self.description = description
        self.project_name = project_name   
        self.extract = Extract(self.log,file_dir_metdata="/Users/bakr/Desktop/personal_projects/energy_forecasting/mlforecasting/feature_pipeline/feature_pipeline/outputs/data")
        self.validation  = Validation(self.log)
        self.cleaning = cleaning.Cleaning(self.log)
        self.hopsworks = Loads(self.log,version=version,
                               description=description,
                               project_name=project_name)
        self.generate_synthetic_data = Generate_Data
    def run(
            self,
            date_reference:Optional[datetime] 
    )->bool:
        try:
              #extraction from api
              # data , metadata = self.extract.from_file(export_end_reference_datetime=date_reference) 
              data,metadata = self.generate_synthetic_data.generate_synthetic_time_series()
              #transforming The data to a better format 
              # data = self.transform(data)
              print(data)
              #validating The data 
              validation_results = self.validation.build_expectation_suites(data)
            #   print("hello")
              #insert into hospworks
              data["energy_consumption"] = data["energy_consumption"].astype(np.int32)
              data["area"] = data["area"].astype(np.int32)
              data["datetime_utc"] = pd.to_datetime(data["datetime_utc"])
              data["consumer_type"]= data["consumer_type"].astype(np.int32)
              self.hopsworks.inserting_to_feature_store(data)
                                            
              print("okkkk")
              
              metadata["featuer_group_version"] = 1
            #   Utils.save_json(metadata,file_name="metdata.json",file_dir=self.file_dir_metadata)
              return True
        except Exception as e:
             self.log.error("something went wrong while insertign the data")
             return False
        
        
    def transform(self,data:pd.DataFrame):
         """
         Wrapper containig all The trasnformation from ETL
         """
         data = self.cleaning.cast_columns(data)
         data = self.cleaning.rename_columns(data)
         data = self.cleaning.type_transformation(data)
         data = self.cleaning.encode_area_columns(data)
         return data
    
if __name__ == "__main__":
    logs = Utils.get_loggers(__name__)
    load_env_var("/Users/bakr/Desktop/personal_projects/energy_forecasting/mlforecasting/feature_pipeline/.env")
    pips = Pipeline(logs,6,feature_gp_name=os.environ.get("HOPS_WORKS_GP_NAME"),description="none",project_name=os.environ.get("HOPSWORKS_PROJECT_NAME"))
    a = pips.run(datetime(2023,6,30,21,0,0))