import logging 
import settings
from pathlib import Path
import json
import os
import pandas as pd 
from typing import Optional

class Utils():
        def __init__(self):
             pass
        @staticmethod
        def get_loggers(
            name:str    
        ) -> logging.Logger:
            """Function to save Logs for future analysis and use"""
            logger = logging.getLogger(name)
            logging.basicConfig(filename=os.getcwd()+"/outputs/logs.log",encoding="utf-8",level=logging.INFO)
            return logger
        
        @staticmethod
        def save_json(data: dict, file_name: str, file_dir: Optional[str]):
            data_path = Path(file_dir)
            file_path = data_path / file_name
            try:
                if not data_path.exists():
                    os.makedirs(data_path)

                with open(file_path, "w") as f:
                    json.dump(data, f,indent=4)
            except Exception as e:
                raise Exception("Couldn't save the data into our system!") from e    
        
        @staticmethod
        def load_json(
                  file_name : str , file_dir : str  = settings.OUTPUT_DIR
        ):
            data_path = Path(file_dir)/file_name
            if  data_path.exists():
                raise FileNotFoundError(f"Cached JSON frame doesn't exists")
            with open(data_path,"r") as f :
                data = json.load(f)
            return data
        

# if __name__ == "__main__":
#      data = {
#           "name":["baker","lawzi","ahmad"],
#           "lastname":[1,2,3,4]
#      } 
#     #  Utils.save_json(data,"metadat.json")
#      Utils.save_json(data=data,file_dir="/Users/bakr/Desktop/personal_projects/energy_forecasting/mlforecasting/feature_pipeline/feature_pipeline",file_name="metadata.json")


    

    