import os
from  pathlib import Path
from typing import Union, Optional
from dotenv import load_dotenv


def load_env_var(root_dir : Union[Path , str]) -> dict :
    """
    Loads environment variables from .env file into os.environ
    """
    if isinstance(root_dir,str):
        root_dir = Path(root_dir)
    env_path = root_dir/".env"
    if not env_path.exists():
        raise FileNotFoundError(f"No .env file found at {env_path}")
    load_dotenv(env_path)

def get_root_user(default_value: str = "../")->Path:
    """"
        Helps you to get The root of The project
    """
    return Path(os.environ.get("ML_PIPELINE_ROOT_DIR",default_value))



ML_PIPELINE_ROOT_DIR = get_root_user()
OUTPUT_DIR = ML_PIPELINE_ROOT_DIR/"outputs"
OUTPUT_DIR.mkdir(parents=True,exist_ok=True)
SETTINGS = load_env_var(root_dir=ML_PIPELINE_ROOT_DIR)